#include "mk7a21p.inc" 

length_counter  equ             49h          	;ʱ
delay_counter1 	equ 		41h          	;ʱ 
delay_counter2 	equ 		42h          	;ʱ 
delay_counter3 	equ 		43h          	;ʱ 
s0_data        	equ 		44h          	;S0ķ 
s1_data        	equ 		45h          	;S1ķ 
s2_data        	equ 		46h          	;S2ķ 
s_temp         	equ 		47h          	;ݴ 
byte_counter   	equ 		48h          	;λ 
;----------------------------------- 
		org 		00h 
        	lcall 		initial		;óʼ 
main_loop: 
        	lcall 		scan_key_loop	;ðɨ 
        	movla 		04fh 
        	movam 		length_counter 
        	lcall 		delay           ;ʱ 
        	lgoto 		main_loop 
;----------------------------------- 
;ʱӳ 
delay: 
       		mov 		length_counter,a 
       		movam 		delay_counter1 
loop4: 	
		decsz 		delay_counter1,m 
       		lgoto 		loop1 
       		lgoto 		return 
loop1: 
       		mov 		length_counter,a 
       		movam 		delay_counter2 
loop6: 
		decsz 		delay_counter2,m 
       		lgoto 		loop2 
       		lgoto 		loop4 
loop2: 
       		mov 		length_counter,a 
       		movam 		delay_counter3 
loop3:  
       		nop 
       		decsz 		delay_counter3,m 
       		lgoto 		loop3 
       		lgoto 		loop6 
return: 
       		ret 
;----------------------------------- 
;ɨӳ 
scan_key_loop: 
        	btss 		pa_dat,b0	;ɨS0 
        	lgoto 		scan_key_loop4 
        	lgoto 		scan_key_loop1 
scan_key_loop4: 
        	btss 		pa_dat,b0  	;жS0Ƿɿ 
        	lgoto 		scan_key_loop4 
        	lcall 		s0_send      	;S0źŴӳ 
        	lgoto 		scan_key_loop3 
scan_key_loop1: 
        	btss 		pa_dat,b1    	;ɨS1 
       	 	lgoto 		scan_key_loop5 
        	lgoto 		scan_key_loop2 
scan_key_loop5: 
        	btss 		pa_dat,b1     	;жS1Ƿɿ 
        	lgoto 		scan_key_loop5 
        	lcall 		s1_send       	;S1źŴӳ 
        	lgoto 		scan_key_loop3 
scan_key_loop2: 
        	btss 		pa_dat,b2     	;ɨS2 
        	lgoto 		scan_key_loop6 
        	lgoto 		scan_key_loop 
scan_key_loop6: 
        	btss 		pa_dat,b2     	;жS2Ƿɿ 
        	lgoto 		scan_key_loop6 
        	lcall	 	s2_send      	;S2źŴӳ 
        	lgoto 		scan_key_loop3 
scan_key_loop3: 
        	ret 
;----------------------------------- 
;S0źŴӳ 
s0_send: 
        	lcall 		lead_send     	;ʼźŷӳ 
        	mov 		s0_data,a 
        	movam 		s_temp 
        	movla 		08h          	;λΪ8һֽ 
        	movam 		byte_counter 
s0_send_loop4: 
        	btsc 		s_temp,b0     	;жϵ0λ10 
        	lgoto 		s0_send_loop3 
        	lgoto 		s0_send_loop2 
s0_send_loop3: 
        	rr 		s_temp,m     	; 
        	lcall 		bit1_send    	;÷BIT1ӳ 
        	decsz 		byte_counter,m 
        	lgoto 		s0_send_loop4 
        	lgoto 		s0_send_loop1 
s0_send_loop2: 
        	rr 		s_temp,m    	; 
        	lcall 		bit0_send    	;÷BIT0ӳ 
        	decsz 		byte_counter,m 
        	lgoto 		s0_send_loop4 
        	lgoto 		s0_send_loop1 
s0_send_loop1: 
        	bc   		tm2_ctl1,b7 
        	ret 
;----------------------------------- 
;S1źŴӳ 
s1_send: 
        	lcall 		lead_send 	;ʼźŷӳ 
        	mov 		s1_data,a            
        	movam 		s_temp 
        	movla 		08h         	;λΪ8һֽ 
        	movam 		byte_counter 
s1_send_loop4: 
        	btsc 		s_temp,b0   	;жϵ0λ10 
        	lgoto 		s1_send_loop3 
        	lgoto 		s1_send_loop2 
s1_send_loop3: 
        	rr 		s_temp,m     	; 
        	lcall 		bit1_send   	;÷BIT1ӳ 
        	decsz 		byte_counter,m 
        	lgoto 		s1_send_loop4 
        	lgoto 		s1_send_loop1 
s1_send_loop2: 
        	rr 		s_temp,m      	; 
        	lcall 		bit0_send    	;÷BIT0ӳ 
        	decsz 		byte_counter,m 
        	lgoto 		s1_send_loop4 
        	lgoto 		s1_send_loop1 
s1_send_loop1: 
        	bc   		tm2_ctl1,b7 
        	ret 
;----------------------------------- 
;S2źŴӳ 
s2_send: 
        	lcall 		lead_send    	;ʼźŷӳ 
        	mov 		s2_data,a 
        	movam 		s_temp 
        	movla 		08h          	;λΪ8һֽ 
        	movam 		byte_counter 
s2_send_loop4: 
        	btsc 		s_temp,b0    	;жϵ0λ10 
        	lgoto	 	s2_send_loop3 
        	lgoto 		s2_send_loop2 
s2_send_loop3: 
        	rr 		s_temp,m     	; 
        	lcall 		bit1_send    	;÷BIT1ӳ 
        	decsz 		byte_counter,m 
        	lgoto 		s2_send_loop4 
        	lgoto 		s2_send_loop1 
s2_send_loop2: 
        	rr 		s_temp,m      	; 
        	lcall 		bit0_send    	;÷BIT0ӳ 
        	decsz 		byte_counter,m 
        	lgoto 		s2_send_loop4 
        	lgoto 		s2_send_loop1 
s2_send_loop1: 
        	bc   		tm2_ctl1,b7 
        	ret 
;----------------------------------- 
; ʼźŷӳ 
lead_send: 
        	bs     		tm2_ctl1,b7 
        	movla  		08h 
        	movam  		length_counter 
        	lcall  		delay 
        	lcall  		delay 
       	 	lcall  		delay 
        	bc     		tm2_ctl1,b7 
        	movla  		08h 
        	movam  		length_counter 
        	lcall  		delay 
        	lcall  		delay 
        	lcall  		delay 
        	ret 
;----------------------------------- 
;BIT0ӳ 
bit0_send: 
        	bc     		tm2_ctl1,b7 
        	movla  		08h 
        	movam  		length_counter 
        	lcall  		delay 
        	bs     		tm2_ctl1,b7 
        	movla  		08h 
        	movam  		length_counter 
        	lcall  		delay 
        	ret 
;----------------------------------- 
;BIT1ӳ 
bit1_send: 
        	bc     		tm2_ctl1,b7 
        	movla  		08h 
        	movam  		length_counter 
        	lcall  		delay 
        	bs     		tm2_ctl1,b7 
        	movla  		08h 
        	movam  		length_counter 
        	lcall  		delay 
        	lcall  		delay 
        	ret 
;----------------------------------- 
;ʼ 
initial: 
;S0S1S2ķ 
        	movla 		b'10010010'  	;S0ʱb'10010010' 
        	movam 		s0_data            
        	movla 		b'10101010'   	;S1ʱb'10101010' 
        	movam 		s1_data 
        	movla 		b'01010101'   	;S2ʱb'01010101' 
        	movam 		s2_data 
;IO 
        	bs  		pa_dir,b0 
        	bs  		pa_dir,b1 
        	bs  		pa_dir,b2 
        	bs  		pa_plu,b0 
        	bs  		pa_plu,b1 
        	bs  		pa_plu,b2 
        	bc  		pc_dir,b0 
;TM2TM3PWM 
        	bs 		tm2_ctl1,b0 
        	bs 		tm2_ctl1,b1 
        	bc 		tm2_ctl1,b2  	;ԤƵΪ18 
        	bc 		tm2_ctl1,b3 	; 
        	bc 		tm2_ctl1,b4 
        	bs 		tm2_ctl1,b5   	;ʱԴΪRC 
        	bs 		tm2_ctl1,b6 
        	bc 		tm2_ctl1,b7   	;رPWM 
        	bc 		tm2_ctl2,b0 
        	bc 		tm2_ctl2,b1 
        	bc 		tm2_ctl2,b2    	;PWMԤƵΪ1:1 
        	bc 		tm2_ctl2,b6 
        	bs 		tm2_ctl2,b7    	;TM2ΪPWMģʽ 
        	bs 		tm3_ctl,b0 
        	bs 		tm3_ctl,b1 
        	bc 		tm3_ctl,b2   	;ԤƵΪ18 
        	bc 		tm3_ctl,b3   	; 
        	bc 		tm3_ctl,b4 
       	 	bs 		tm3_ctl,b5   	;ʱԴΪRC 
       	 	bs 		tm3_ctl,b6 
        	movla 		0ch        	;PWM 
        	movam 		tm2_la 
        	movla 		05h         	;PWMռձ 
        	movam 		tm3_la 
        	ret 
;----------------------------------- 
        	end 